package CHARON.simulator.agents;
import CHARON.simulator.classes.*;
import CHARON.simulator.*;
import CHARON.gui.manager.*;
import CHARON.simulator.modes.*;
import CHARON.simulator.agents.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import  CHARON.user.*;

public class ACoffee extends Agent {

    public ACoffee(HashMap rVars, Vector paramOfThisAgent, Vector analogVarOfThisAgent, Vector discreteVarOfThisAgent, Vector vectorOfAssertions, String name, CHARONSystem sys, Agent agentParent) {
      this(null, rVars, paramOfThisAgent, analogVarOfThisAgent, discreteVarOfThisAgent, vectorOfAssertions, name, sys, agentParent);
}

  public ACoffee(Simulation sim, HashMap rVars, Vector paramOfThisAgent, Vector analogVarOfThisAgent, Vector discreteVarOfThisAgent, Vector vectorOfAssertions, String name, CHARONSystem sys, Agent agentParent) {
    super(sim);
    system = sys;
    setParent(agentParent);
    setAgentName(name);
    newNames = rVars;
    setAgentParams(paramOfThisAgent);
    pathname = getPathName();
    setDiscreteVars(discreteVarOfThisAgent);
    setAnalogVars(analogVarOfThisAgent);
    setAssertions(vectorOfAssertions);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_on"), "Discrete")+getNewName("ack_coffee_on")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_coffee_on") != null) ? getNewName("ack_coffee_on"): "ack_coffee_on"), "Discrete")+((getNewName("ack_coffee_on") != null) ? getNewName("ack_coffee_on"): "ack_coffee_on"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("dec"), "Discrete")+getNewName("dec")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("dec") != null) ? getNewName("dec"): "dec"), "Discrete")+((getNewName("dec") != null) ? getNewName("dec"): "dec"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_done"), "Discrete")+getNewName("ack_coffee_done")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_coffee_done") != null) ? getNewName("ack_coffee_done"): "ack_coffee_done"), "Discrete")+((getNewName("ack_coffee_done") != null) ? getNewName("ack_coffee_done"): "ack_coffee_done"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_coffee"), "Discrete")+getNewName("ack_coffee_coffee")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_coffee_coffee") != null) ? getNewName("ack_coffee_coffee"): "ack_coffee_coffee"), "Discrete")+((getNewName("ack_coffee_coffee") != null) ? getNewName("ack_coffee_coffee"): "ack_coffee_coffee"))).updateValue(false);
    putReadVar(getDiscreteVar(getPathName(getNewName("done"), "Discrete")+getNewName("done")));

    putReadVar(getDiscreteVar(getPathName(getNewName("inc"), "Discrete")+getNewName("inc")));

    putReadVar(getDiscreteVar(getPathName(getNewName("coffee"), "Discrete")+getNewName("coffee")));

    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_inc"), "Discrete")+getNewName("ack_coffee_inc")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_coffee_inc") != null) ? getNewName("ack_coffee_inc"): "ack_coffee_inc"), "Discrete")+((getNewName("ack_coffee_inc") != null) ? getNewName("ack_coffee_inc"): "ack_coffee_inc"))).updateValue(false);
    putReadVar(getDiscreteVar(getPathName(getNewName("poweroff"), "Discrete")+getNewName("poweroff")));

    putReadVar(getDiscreteVar(getPathName(getNewName("m"), "Discrete")+getNewName("m")));

    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_off"), "Discrete")+getNewName("ack_coffee_off")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_coffee_off") != null) ? getNewName("ack_coffee_off"): "ack_coffee_off"), "Discrete")+((getNewName("ack_coffee_off") != null) ? getNewName("ack_coffee_off"): "ack_coffee_off"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("priority"), "Discrete")+getNewName("priority")));
    ((Int)getDiscreteVar(getPathName(((getNewName("priority") != null) ? getNewName("priority"): "priority"), "Discrete")+((getNewName("priority") != null) ? getNewName("priority"): "priority"))).updateValue(0);
    putReadVar(getDiscreteVar(getPathName(getNewName("poweron"), "Discrete")+getNewName("poweron")));


    /* top mode parameters */
    Vector mp = new Vector();
    setModeParams(mp);
    setTopMode(new CHARON.simulator.modes.Coffee(sim, "top", getModeParams(), getAnalogVars(), getDiscreteVars(), getAssertions(), null, this));
  } // end constructor
} // end ACoffee
