package CHARON.simulator.agents;
import CHARON.simulator.classes.*;
import CHARON.simulator.*;
import CHARON.gui.manager.*;
import CHARON.simulator.modes.*;
import CHARON.simulator.agents.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import  CHARON.user.*;

public class AEnvironment extends Agent {

    public AEnvironment(HashMap rVars, Vector paramOfThisAgent, Vector analogVarOfThisAgent, Vector discreteVarOfThisAgent, Vector vectorOfAssertions, String name, CHARONSystem sys, Agent agentParent) {
      this(null, rVars, paramOfThisAgent, analogVarOfThisAgent, discreteVarOfThisAgent, vectorOfAssertions, name, sys, agentParent);
}

  public AEnvironment(Simulation sim, HashMap rVars, Vector paramOfThisAgent, Vector analogVarOfThisAgent, Vector discreteVarOfThisAgent, Vector vectorOfAssertions, String name, CHARONSystem sys, Agent agentParent) {
    super(sim);
    system = sys;
    setParent(agentParent);
    setAgentName(name);
    newNames = rVars;
    setAgentParams(paramOfThisAgent);
    pathname = getPathName();
    setDiscreteVars(discreteVarOfThisAgent);
    setAnalogVars(analogVarOfThisAgent);
    setAssertions(vectorOfAssertions);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_on"), "Discrete")+getNewName("ack_coffee_on")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_coffee_on") != null) ? getNewName("ack_coffee_on"): "ack_coffee_on"), "Discrete")+((getNewName("ack_coffee_on") != null) ? getNewName("ack_coffee_on"): "ack_coffee_on"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_money_inc"), "Discrete")+getNewName("ack_money_inc")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_money_inc") != null) ? getNewName("ack_money_inc"): "ack_money_inc"), "Discrete")+((getNewName("ack_money_inc") != null) ? getNewName("ack_money_inc"): "ack_money_inc"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_done"), "Discrete")+getNewName("ack_coffee_done")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_coffee_done") != null) ? getNewName("ack_coffee_done"): "ack_coffee_done"), "Discrete")+((getNewName("ack_coffee_done") != null) ? getNewName("ack_coffee_done"): "ack_coffee_done"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_money_off"), "Discrete")+getNewName("ack_money_off")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_money_off") != null) ? getNewName("ack_money_off"): "ack_money_off"), "Discrete")+((getNewName("ack_money_off") != null) ? getNewName("ack_money_off"): "ack_money_off"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("done"), "Discrete")+getNewName("done")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("done") != null) ? getNewName("done"): "done"), "Discrete")+((getNewName("done") != null) ? getNewName("done"): "done"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_coffee"), "Discrete")+getNewName("ack_coffee_coffee")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_coffee_coffee") != null) ? getNewName("ack_coffee_coffee"): "ack_coffee_coffee"), "Discrete")+((getNewName("ack_coffee_coffee") != null) ? getNewName("ack_coffee_coffee"): "ack_coffee_coffee"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("inc"), "Discrete")+getNewName("inc")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("inc") != null) ? getNewName("inc"): "inc"), "Discrete")+((getNewName("inc") != null) ? getNewName("inc"): "inc"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("coffee"), "Discrete")+getNewName("coffee")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("coffee") != null) ? getNewName("coffee"): "coffee"), "Discrete")+((getNewName("coffee") != null) ? getNewName("coffee"): "coffee"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_inc"), "Discrete")+getNewName("ack_coffee_inc")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_coffee_inc") != null) ? getNewName("ack_coffee_inc"): "ack_coffee_inc"), "Discrete")+((getNewName("ack_coffee_inc") != null) ? getNewName("ack_coffee_inc"): "ack_coffee_inc"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("poweroff"), "Discrete")+getNewName("poweroff")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("poweroff") != null) ? getNewName("poweroff"): "poweroff"), "Discrete")+((getNewName("poweroff") != null) ? getNewName("poweroff"): "poweroff"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_off"), "Discrete")+getNewName("ack_coffee_off")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_coffee_off") != null) ? getNewName("ack_coffee_off"): "ack_coffee_off"), "Discrete")+((getNewName("ack_coffee_off") != null) ? getNewName("ack_coffee_off"): "ack_coffee_off"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_money_coffee"), "Discrete")+getNewName("ack_money_coffee")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_money_coffee") != null) ? getNewName("ack_money_coffee"): "ack_money_coffee"), "Discrete")+((getNewName("ack_money_coffee") != null) ? getNewName("ack_money_coffee"): "ack_money_coffee"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_money_on"), "Discrete")+getNewName("ack_money_on")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_money_on") != null) ? getNewName("ack_money_on"): "ack_money_on"), "Discrete")+((getNewName("ack_money_on") != null) ? getNewName("ack_money_on"): "ack_money_on"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("priority"), "Discrete")+getNewName("priority")));
    ((Int)getDiscreteVar(getPathName(((getNewName("priority") != null) ? getNewName("priority"): "priority"), "Discrete")+((getNewName("priority") != null) ? getNewName("priority"): "priority"))).updateValue(0);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("poweron"), "Discrete")+getNewName("poweron")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("poweron") != null) ? getNewName("poweron"): "poweron"), "Discrete")+((getNewName("poweron") != null) ? getNewName("poweron"): "poweron"))).updateValue(false);
    putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_money_done"), "Discrete")+getNewName("ack_money_done")));
    ((Bool)getDiscreteVar(getPathName(((getNewName("ack_money_done") != null) ? getNewName("ack_money_done"): "ack_money_done"), "Discrete")+((getNewName("ack_money_done") != null) ? getNewName("ack_money_done"): "ack_money_done"))).updateValue(false);

    /* top mode parameters */
    Vector mp = new Vector();
    setModeParams(mp);
    setTopMode(new CHARON.simulator.modes.Environment(sim, "top", getModeParams(), getAnalogVars(), getDiscreteVars(), getAssertions(), null, this));
  } // end constructor
} // end AEnvironment
